- include_role:
    name: directory
    tasks_from: wait.yaml
  vars:
    check_only: True
    in_namespace: "{{ auth_namespace | default(namespace) }}"
    obj_selectors: "{{ directory_selectors | default([ 'opsperator.io/' ~ cr_kind ~ '=' ~ cr_name ]) }}"
- block:
  - include_role:
      name: minio
      tasks_from: wait.yaml
    vars:
      in_namespace: "{{ minio_namespace | default(namespace) }}"
    when:
    - thanos_s3_flavor == 'minio'
  - include_role:
      name: radosgw
      tasks_from: wait.yaml
    vars:
      in_namespace: "{{ rgw_namespace | default(namespace) }}"
    when:
    - thanos_s3_flavor in [ 'ceph', 'rados', 'radosgw' ]
  when:
  - do_thanos
- include_role:
    name: postfix
    tasks_from: wait.yaml
  vars:
    check_only: True
    in_namespace: "{{ postfix_namespace | default(namespace) }}"
    obj_selectors: "{{ postfix_selectors | default([ 'opsperator.io/' ~ cr_kind ~ '=' ~ cr_name ]) }}"
  when:
  - smtp_relay is not defined
- name: Sets Prometheus Plan Facts
  set_fact:
    alertmanager_do_fusion: "{{ True if (fusion_address is defined
                                         and fusion_address != 'not deployed'
                                         and directory_crd.resources | length > 0
                                         and directory_crd.resources[0].spec is defined
                                         and directory_crd.resources[0].spec.do_alertmanager | default(False)
                                         and directory_crd.resources[0].spec.do_fusion | default(False))
                                     else False }}"
    alertmanager_do_ldap: "{{ True if (ldap_address is defined
                                       and directory_crd.resources | length > 0
                                       and directory_crd.resources[0].spec is defined
                                       and directory_crd.resources[0].spec.do_alertmanager | default(False))
                                   else False }}"
    alertmanager_do_lemon: "{{ True if (lemon_manager is defined
                                        and lemon_manager != 'not deployed'
                                        and directory_crd.resources | length > 0
                                        and directory_crd.resources[0].spec is defined
                                        and directory_crd.resources[0].spec.do_alertmanager | default(False))
                                    else False }}"
    alertmanager_do_oc: "{{ True if (k8s_flavor == 'openshift' and do_oc)
                                 else False }}"
    alertmanager_fqdn: "{{ (alertmanager_force_fqdn | default(False))
                             if (alertmanager_force_fqdn | default(False))
                             else ((directory_crd.resources[0].spec.directory_fqdn_alertmanager | default(False))
                                   if (directory_cr is defined
                                       and directory_crd.resources is defined
                                       and directory_crd.resources | length > 0
                                       and directory_crd.resources[0].spec is defined
                                       and directory_crd.resources[0].spec.directory_fqdn_alertmanager is defined
                                       and directory_crd.resources[0].spec.do_alertmanager | default(False))
                                   else ('alertmanager.' ~ root_domain)) }}"
    grafana_do_fusion: "{{ True if (fusion_address is defined
                                    and fusion_address != 'not deployed'
                                    and directory_crd.resources | length > 0
                                    and directory_crd.resources[0].spec is defined
                                    and directory_crd.resources[0].spec.do_fusion | default(False)
                                    and directory_crd.resources[0].spec.do_grafana | default(False))
                                else False }}"
    grafana_do_ldap: "{{ True if (ldap_address is defined
                                  and directory_crd.resources | length > 0
                                  and directory_crd.resources[0].spec is defined
                                  and directory_crd.resources[0].spec.do_grafana | default(False))
                              else False }}"
    grafana_do_lemon: "{{ True if (lemon_manager is defined
                                   and lemon_manager != 'not deployed'
                                   and directory_crd.resources | length > 0
                                   and directory_crd.resources[0].spec is defined
                                   and directory_crd.resources[0].spec.do_grafana | default(False))
                               else False }}"
    grafana_do_oc: "{{ True if (k8s_flavor == 'openshift' and do_oc)
                            else False }}"
    grafana_fqdn: "{{ (grafana_force_fqdn | default(False))
                        if (grafana_force_fqdn | default(False))
                        else ((directory_crd.resources[0].spec.directory_fqdn_grafana | default(False))
                              if (directory_cr is defined
                                  and directory_crd.resources is defined
                                  and directory_crd.resources | length > 0
                                  and directory_crd.resources[0].spec is defined
                                  and directory_crd.resources[0].spec.directory_fqdn_grafana is defined
                                  and directory_crd.resources[0].spec.do_grafana | default(False))
                              else ('grafana.' ~ root_domain)) }}"
    prometheus_do_fusion: "{{ True if (fusion_address is defined
                                       and fusion_address != 'not deployed'
                                       and directory_crd.resources | length > 0
                                       and directory_crd.resources[0].spec is defined
                                       and directory_crd.resources[0].spec.do_fusion | default(False)
                                       and directory_crd.resources[0].spec.do_prometheus | default(False))
                                   else False }}"
    prometheus_do_ldap: "{{ True if (ldap_address is defined
                                     and directory_crd.resources | length > 0
                                     and directory_crd.resources[0].spec is defined
                                     and directory_crd.resources[0].spec.do_prometheus | default(False))
                                 else False }}"
    prometheus_do_lemon: "{{ True if (lemon_manager is defined
                                      and lemon_manager != 'not deployed'
                                      and directory_crd.resources | length > 0
                                      and directory_crd.resources[0].spec is defined
                                      and directory_crd.resources[0].spec.do_prometheus | default(False))
                                  else False }}"
    prometheus_do_oc: "{{ True if (k8s_flavor == 'openshift' and do_oc)
                               else False }}"
    prometheus_fqdn: "{{ (prometheus_force_fqdn | default(False))
                           if (prometheus_force_fqdn | default(False))
                           else ((directory_crd.resources[0].spec.directory_fqdn_prometheus | default(False))
                                 if (directory_cr is defined
                                     and directory_crd.resources is defined
                                     and directory_crd.resources | length > 0
                                     and directory_crd.resources[0].spec is defined
                                     and directory_crd.resources[0].spec.directory_fqdn_prometheus is defined
                                     and directory_crd.resources[0].spec.do_prometheus | default(False))
                                 else ('prometheus.' ~ root_domain)) }}"
    thanos_do_fusion: "{{ True if (fusion_address is defined
                                   and fusion_address != 'not deployed'
                                   and directory_crd.resources | length > 0
                                   and directory_crd.resources[0].spec is defined
                                   and directory_crd.resources[0].spec.do_thanos | default(False)
                                   and directory_crd.resources[0].spec.do_fusion | default(False))
                               else False }}"
    thanos_do_ldap: "{{ True if (ldap_address is defined
                                 and directory_crd.resources | length > 0
                                 and directory_crd.resources[0].spec is defined
                                 and directory_crd.resources[0].spec.do_thanos | default(False))
                             else False }}"
    thanos_do_lemon: "{{ True if (lemon_manager is defined
                                  and lemon_manager != 'not deployed'
                                  and directory_crd.resources | length > 0
                                  and directory_crd.resources[0].spec is defined
                                  and directory_crd.resources[0].spec.do_thanos | default(False))
                              else False }}"
    thanos_do_oc: "{{ True if (k8s_flavor == 'openshift' and do_oc)
                           else False }}"
    thanos_fqdn: "{{ (thanos_force_fqdn | default(False))
                       if (thanos_force_fqdn | default(False))
                       else ((directory_crd.resources[0].spec.directory_fqdn_thanos | default(False))
                             if (directory_cr is defined
                                 and directory_crd.resources is defined
                                 and directory_crd.resources | length > 0
                                 and directory_crd.resources[0].spec is defined
                                 and directory_crd.resources[0].spec.directory_fqdn_thanos is defined
                                 and directory_crd.resources[0].spec.do_thanos | default(False))
                             else ('thanos.' ~ root_domain)) }}"
    thanosbucket_do_fusion: "{{ True if (fusion_address is defined
                                         and fusion_address != 'not deployed'
                                         and directory_crd.resources | length > 0
                                         and directory_crd.resources[0].spec is defined
                                         and directory_crd.resources[0].spec.do_thanos_bucket | default(False)
                                         and directory_crd.resources[0].spec.do_fusion | default(False))
                                     else False }}"
    thanosbucket_do_ldap: "{{ True if (ldap_address is defined
                                       and directory_crd.resources | length > 0
                                       and directory_crd.resources[0].spec is defined
                                       and directory_crd.resources[0].spec.do_thanos_bucket | default(False))
                                   else False }}"
    thanosbucket_do_lemon: "{{ True if (lemon_manager is defined
                                        and lemon_manager != 'not deployed'
                                        and directory_crd.resources | length > 0
                                        and directory_crd.resources[0].spec is defined
                                        and directory_crd.resources[0].spec.do_thanos_bucket | default(False))
                                    else False }}"
    thanosbucket_do_oc: "{{ True if (k8s_flavor == 'openshift' and do_oc)
                                 else False }}"
    thanosbucket_fqdn: "{{ (thanosbucket_force_fqdn | default(False))
                             if (thanosbucket_force_fqdn | default(False))
                             else ((directory_crd.resources[0].spec.directory_fqdn_thanos_bucket | default(False))
                                   if (directory_cr is defined
                                       and directory_crd.resources is defined
                                       and directory_crd.resources | length > 0
                                       and directory_crd.resources[0].spec is defined
                                       and directory_crd.resources[0].spec.directory_fqdn_thanos_bucket is defined
                                       and directory_crd.resources[0].spec.do_thanos_bucket | default(False))
                                   else ('thanos-bucket.' ~ root_domain)) }}"
# thanos-receive would remain open until further notice ....
#    thanosreceive_do_fusion: "{{ True if (fusion_address is defined
#                                          and fusion_address != 'not deployed'
#                                          and directory_crd.resources | length > 0
#                                          and directory_crd.resources[0].spec is defined
#                                          and directory_crd.resources[0].spec.do_thanos_receive | default(False)
#                                          and directory_crd.resources[0].spec.do_fusion | default(False))
#                                      else False }}"
#    thanosreceive_do_ldap: "{{ True if (ldap_address is defined
#                                        and directory_crd.resources | length > 0
#                                        and directory_crd.resources[0].spec is defined
#                                        and directory_crd.resources[0].spec.do_thanos_receive | default(False))
#                                    else False }}"
#    thanosreceive_do_lemon: "{{ True if (lemon_manager is defined
#                                         and lemon_manager != 'not deployed'
#                                         and directory_crd.resources | length > 0
#                                         and directory_crd.resources[0].spec is defined
#                                         and directory_crd.resources[0].spec.do_thanos_receive | default(False))
#                                     else False }}"
#    thanosreceive_do_oc: "{{ True if (k8s_flavor == 'openshift' and do_oc)
#                                  else False }}"
    thanosreceive_fqdn: "{{ (thanosreceive_force_fqdn | default(False))
                              if (thanosreceive_force_fqdn | default(False))
                              else ((directory_crd.resources[0].spec.directory_fqdn_thanos_receive | default(False))
                                    if (directory_cr is defined
                                        and directory_crd.resources is defined
                                        and directory_crd.resources | length > 0
                                        and directory_crd.resources[0].spec is defined
                                        and directory_crd.resources[0].spec.directory_fqdn_thanos_receive is defined
                                        and directory_crd.resources[0].spec.do_thanos_receive | default(False))
                                    else ('thanos-receive.' ~ root_domain)) }}"
- name: Fail if SMTP relay missing
  fail:
    msg:
     Can not deploy AlertManager and Email-based alerting, without some SMTP
     server available, either create a Postfix CR, or fill in the smtp_relay
     param of your Prometheus CR.
  when:
  - smtp_relay is not defined
  - smtp_address is not defined
  - smtps_address is not defined
  - do_alertmanager
  - notify_email_address | default(False)
  - not notify_http_address | default(False)
  - not notify_slack_address | default(False)
  - not notify_teams_address | default(False)
- block:
  - name: Fixes Directory Prometheus FQDN
    async: 30
    k8s:
      definition:
        apiVersion: wopla.io/v1beta1
        kind: Directory
        metadata:
          name: "{{ directory_crd.resources[0].metadata.name }}"
          namespace: "{{ ldap_namespace }}"
        spec:
          directory_fqdn_alertmanager: "{{ alertmanager_fqdn }}"
          directory_fqdn_grafana: "{{ grafana_fqdn }}"
          directory_fqdn_prometheus: "{{ prometheus_fqdn }}"
          directory_fqdn_thanos: "{{ thanos_fqdn }}"
          directory_fqdn_thanos_bucket: "{{ thanosbucket_fqdn }}"
          directory_fqdn_thanos_receive: "{{ thanosreceive_fqdn }}"
    when:
    - ldap_root_domain is defined
    - ldap_root_domain != root_domain
    - directory_cr is defined
    - directory_crd.resources is defined
    - directory_crd.resources | length > 0
    - directory_crd.resources[0].spec is defined
    - >
        (directory_crd.resources[0].spec.directory_fqdn_alertmanager | default('alertmanager.' ~ ldap_root_domain)) != alertmanager_fqdn
        or (directory_crd.resources[0].spec.directory_fqdn_grafana | default('grafana.' ~ ldap_root_domain)) != grafana_fqdn
        or (directory_crd.resources[0].spec.directory_fqdn_prometheus | default('prometheus.' ~ ldap_root_domain)) != prometheus_fqdn
        or (directory_crd.resources[0].spec.directory_fqdn_thanos | default('thanos.' ~ ldap_root_domain)) != thanos_fqdn
        or (directory_crd.resources[0].spec.directory_fqdn_thanos_bucket | default('thanos-bucket.' ~ ldap_root_domain)) != thanosbucket_fqdn
        or (directory_crd.resources[0].spec.directory_fqdn_thanos_receive | default('thanos-receive.' ~ ldap_root_domain)) != thanosreceive_fqdn
  - block:
    - include_role:
        name: directory
        tasks_from: client-config.yaml
      vars:
        config_namespace: "{{ namespace }}"
    - include_role:
        name: directory
        tasks_from: secret-dup.yaml
      vars:
        get_keys:
        - alertmanager-oauth2-secret
        - authproxy-password
        - grafana-password
        - grafana-oauth2-secret
        - directory-root
        - prometheus-oauth2-secret
        - thanos-oauth2-secret
        - thanosbucket-oauth2-secret
        - thanosreceive-oauth2-secret
    when:
    - ldap_namespace != namespace
  - name: Fetches LDAP Secret
    async: 30
    changed_when: False
    failed_when: False
    k8s_info:
      api_version: v1
      kind: Secret
      namespace: "{{ namespace }}"
      name: "{{ ldap_secret_name }}"
    no_log: True
    poll: 5
    register: ldap_secret
  - include_role:
      name: commons
      tasks_from: ssl/ca-init.yaml
    vars:
      tls_provider: "{{ directory_tls_provider }}"
    when:
    - k8s_flavor == 'kubernetes'
    - directory_tls_provider != tls_provider
  when:
  - >
      prometheus_do_ldap or prometheus_do_lemon
      or alertmanager_do_ldap or alertmanager_do_lemon
      or grafana_do_ldap or grafana_do_lemon
      or thanos_do_ldap or thanos_do_lemon
      or thanosbucket_do_ldap or thanosbucket_do_lemon
- include_role:
    name: commons
    tasks_from: ssl/ca-init.yaml
  when:
  - k8s_flavor == 'kubernetes'
- block:
  - include_role:
      name: commons
      tasks_from: helpers/imagestream.yaml
    vars:
      is_import:
      - source: "{{ alertmanager_image_source }}"
        tag: "{{ alertmanager_tag }}"
      is_name: alertmanager
      namespace: "{{ buildns }}"
  - include_role:
      name: commons
      tasks_from: helpers/imagestream.yaml
    vars:
      is_import:
      - source: "{{ certmanagerexporter_image_source }}"
        tag: "{{ certmanagerexporter_tag }}"
      is_name: certmanagerexporter
      namespace: "{{ buildns }}"
  - include_role:
      name: commons
      tasks_from: helpers/imagestream.yaml
    vars:
      is_import:
      - source: "{{ grafana_image_source }}"
        tag: "{{ grafana_tag }}"
      is_name: grafana
      namespace: "{{ buildns }}"
  - include_role:
      name: commons
      tasks_from: helpers/imagestream.yaml
    vars:
      is_import:
      - source: "{{ kubestatemetrics_image_source }}"
        tag: "{{ kubestatemetrics_tag }}"
      is_name: kubestatemetrics
      namespace: "{{ buildns }}"
  - include_role:
      name: commons
      tasks_from: helpers/imagestream.yaml
    vars:
      is_import:
      - source: "{{ nodeexporter_image_source }}"
        tag: "{{ nodeexporter_tag }}"
      is_name: nodeexporter
      namespace: "{{ buildns }}"
  - include_role:
      name: commons
      tasks_from: helpers/imagestream.yaml
    vars:
      is_import:
      - source: "{{ prometheus_image_source }}"
        tag: "{{ prometheus_tag }}"
      is_name: prometheus
      namespace: "{{ buildns }}"
  - include_role:
      name: commons
      tasks_from: helpers/imagestream.yaml
    vars:
      is_import:
      - source: "{{ oauthproxy_image_source }}"
        tag: "{{ oauthproxy_tag }}"
      is_name: oauthproxy
      namespace: "{{ buildns }}"
    when:
    - do_oc | default(False)
  when:
  - k8s_flavor == 'openshift'
- name: "Lookups Prometheus Deployment"
  async: 30
  changed_when: False
  failed_when: False
  k8s_info:
    api_version: "{{ sts_apivers }}"
    kind: StatefulSet
    namespace: "{{ namespace }}"
    name: "{{ prometheus_name }}"
  no_log: True
  poll: 5
  register: pm_dc
- name: "Lookups AlertManager Deployment"
  async: 30
  changed_when: False
  failed_when: False
  k8s_info:
    api_version: "{{ sts_apivers }}"
    kind: StatefulSet
    namespace: "{{ namespace }}"
    name: "{{ alertmanager_name }}"
  no_log: True
  poll: 5
  register: am_dc
- name: "Lookups Grafana Deployment"
  async: 30
  changed_when: False
  failed_when: False
  k8s_info:
    api_version: "{{ deployment_apivers }}"
    kind: "{{ deployment_kind }}"
    namespace: "{{ namespace }}"
    name: "{{ grafana_name }}"
  no_log: True
  poll: 5
  register: gf_dc
- name: "Lookups Thanos Deployment"
  async: 30
  changed_when: False
  failed_when: False
  k8s_info:
    api_version: "{{ sts_apivers }}"
    kind: StatefulSet
    namespace: "{{ namespace }}"
    name: "{{ thanos_name }}-store"
  no_log: True
  poll: 5
  register: tn_dc
